Arch 3Views: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
m (Icon)
Line 3: Line 3:
<translate>
<translate>
<!--T:25-->
<!--T:25-->
{{docnav|[[Arch_ToggleIfcBrepFlag|Toggle IFC Brep flag]]|[[Arch_MakeIfcSpreadsheet|Create IFC spreadsheet...]]|[[Arch_Module|Arch]]}}
{{docnav|[[Arch_ToggleIfcBrepFlag|Toggle IFC Brep flag]]|[[Arch_MakeIfcSpreadsheet|Create IFC spreadsheet...]]|[[Arch_Module|Arch]]|IconL=Arch_ToggleIfcBrepFlag.svg |IconC=Workbench_Arch.svg |IconR=Arch_Schedule.svg}}


<!--T:1-->
<!--T:1-->
Line 82: Line 82:


<!--T:26-->
<!--T:26-->
{{docnav|[[Arch_ToggleIfcBrepFlag|Toggle IFC Brep flag]]|[[Arch_MakeIfcSpreadsheet|Create IFC spreadsheet...]]|[[Arch_Module|Arch]]}}
{{docnav|[[Arch_ToggleIfcBrepFlag|Toggle IFC Brep flag]]|[[Arch_MakeIfcSpreadsheet|Create IFC spreadsheet...]]|[[Arch_Module|Arch]]|IconL=Arch_ToggleIfcBrepFlag.svg |IconC=Workbench_Arch.svg |IconR=Arch_Schedule.svg}}

<!--T:11-->
[[Category:Arch]]

<!--T:24-->
{{Arch Tools navi}}
{{Arch Tools navi}}
{{Userdocnavi}}
{{Userdocnavi}}

Revision as of 19:05, 9 February 2019

This documentation is not finished. Please help and contribute documentation.

GuiCommand model explains how commands should be documented. Browse Category:UnfinishedDocu to see more incomplete pages like this one. See Category:Command Reference for all commands.

See WikiPages to learn about editing the wiki pages, and go to Help FreeCAD to learn about other ways in which you can contribute.

Arch 3Views

Menu location
Arch → Utilities → 3 Views from mesh
Workbenches
Arch
Default shortcut
None
Introduced in version
-
See also
Arch SplitMesh, Arch MeshToShape

Description

This command is currently not in use. It will serve to generate flat, shape-based views from a Mesh based object, to be used by the Arch Equipment tool.

How to use

  1. Select a Mesh object.
  2. Select menu Arch → Utilities → 3Views.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

This tool can be used in macros and from the Python console by using the following function:

shape = createMeshView(obj, direction=FreeCAD.Vector(0, 0, -1), outeronly=False, largestonly=False)
  • Creates a flat shape that is the projection of the given mesh object (obj) in the given direction.
  • If outeronly is True only the outer contour is taken into consideration, discarding the inner holes.
  • If largestonly is True only the largest segment of the given mesh will be used.

Use Part.show() to display the resulting flat shape.

Example:

import FreeCAD, Draft, Arch, Mesh, MeshPart

Line = Draft.makeWire([FreeCAD.Vector(0, 0, 0), FreeCAD.Vector(2000, 2000, 0)])
Wall = Arch.makeWall(Line, width=150, height=3000)
FreeCAD.ActiveDocument.recompute()

Shape = Wall.Shape.copy(False)
Shape.Placement = Wall.getGlobalPlacement()

mesh_obj = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
mesh_obj.Mesh = MeshPart.meshFromShape(Shape=Shape, MaxLength=520)
mesh_obj.ViewObject.DisplayMode = "Flat Lines"
FreeCAD.ActiveDocument.recompute()

XAxis = FreeCAD.Vector(1, 0, 0)
YAxis = FreeCAD.Vector(0, 1, 0)
ZAxis = FreeCAD.Vector(0, 0, -1)

s1 = Arch.createMeshView(mesh_obj, ZAxis)
s2 = Arch.createMeshView(mesh_obj, XAxis)
s3 = Arch.createMeshView(mesh_obj, YAxis)

Part.show(s1)
Part.show(s2)
Part.show(s3)

Wall.ViewObject.Visibility = False
mesh_obj.ViewObject.Visibility = False